/*
*	New C++ File starts here.
*	This file should be named rcs_observern.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "rcs_observern.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : rcs_observerFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
int rcs_observerFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case RCS_OBSERVER_HALT_TYPE:
		((RCS_OBSERVER_HALT *) buffer)->update(cms);
		break;
	case RCS_OBSERVER_INIT_TYPE:
		((RCS_OBSERVER_INIT *) buffer)->update(cms);
		break;
	case RCS_OBSERVER_RUN_TYPE:
		((RCS_OBSERVER_RUN *) buffer)->update(cms);
		break;
	case RCS_OBSERVER_SET_GAINS_TYPE:
		((RCS_OBSERVER_SET_GAINS *) buffer)->update(cms);
		break;
	case RCS_OBSERVER_STATUS_TYPE:
		((RCS_OBSERVER_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *rcs_observer_symbol_lookup(int type)
{
	switch(type)
	{
	case RCS_OBSERVER_HALT_TYPE:
		return "RCS_OBSERVER_HALT";
	case RCS_OBSERVER_INIT_TYPE:
		return "RCS_OBSERVER_INIT";
	case RCS_OBSERVER_RUN_TYPE:
		return "RCS_OBSERVER_RUN";
	case RCS_OBSERVER_SET_GAINS_TYPE:
		return "RCS_OBSERVER_SET_GAINS";
	case RCS_OBSERVER_STATUS_TYPE:
		return "RCS_OBSERVER_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for RCS_OBSERVER_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
void RCS_OBSERVER_INIT::update(CMS *cms)
{
	cms->update(cycle_time);

}


/*
*	NML/CMS Update function for RCS_OBSERVER_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
void RCS_OBSERVER_STATUS::update(CMS *cms)
{
	cms->update(observer_state,4);
	cms->update(current_time);
	cms->update(ctrl_input);
	cms->update(plant_output);

}


/*
*	NML/CMS Update function for RCS_OBSERVER_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
void RCS_OBSERVER_RUN::update(CMS *cms)
{
	cms->update(num_sim_per_cycle);
	cms->update(initial_time);
	cms->update(initial_state,4);

}


/*
*	NML/CMS Update function for RCS_OBSERVER_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
void RCS_OBSERVER_SET_GAINS::update(CMS *cms)
{
	cms->update(observer_gains,4);

}


/*
*	NML/CMS Update function for RCS_OBSERVER_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
void RCS_OBSERVER_HALT::update(CMS *cms)
{

}

/*
*	Constructor for RCS_OBSERVER_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
RCS_OBSERVER_INIT::RCS_OBSERVER_INIT()
	: RCS_CMD_MSG(RCS_OBSERVER_INIT_TYPE,sizeof(RCS_OBSERVER_INIT))
{
	cycle_time = (double) 0;

}

/*
*	Constructor for RCS_OBSERVER_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
RCS_OBSERVER_STATUS::RCS_OBSERVER_STATUS()
	: RCS_STAT_MSG(RCS_OBSERVER_STATUS_TYPE,sizeof(RCS_OBSERVER_STATUS))
{
	/*
	* The array observer_state should be initialized here.
	*/

	current_time = (double) 0;
	ctrl_input = (double) 0;
	plant_output = (double) 0;

}

/*
*	Constructor for RCS_OBSERVER_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
RCS_OBSERVER_RUN::RCS_OBSERVER_RUN()
	: RCS_CMD_MSG(RCS_OBSERVER_RUN_TYPE,sizeof(RCS_OBSERVER_RUN))
{
	num_sim_per_cycle = (int) 0;
	initial_time = (double) 0;
	/*
	* The array initial_state should be initialized here.
	*/


}

/*
*	Constructor for RCS_OBSERVER_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
RCS_OBSERVER_SET_GAINS::RCS_OBSERVER_SET_GAINS()
	: RCS_CMD_MSG(RCS_OBSERVER_SET_GAINS_TYPE,sizeof(RCS_OBSERVER_SET_GAINS))
{
	/*
	* The array observer_gains should be initialized here.
	*/


}

/*
*	Constructor for RCS_OBSERVER_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Dec 17 18:20:09 EST 2000
*/
RCS_OBSERVER_HALT::RCS_OBSERVER_HALT()
	: RCS_CMD_MSG(RCS_OBSERVER_HALT_TYPE,sizeof(RCS_OBSERVER_HALT))
{

}

