/*
rcs_observern.hh

This C++ header file defines the NML Messages used for command and status by RCS_OBSERVER_MODULE
Template Version 1.1

MODIFICATIONS:
Sun Dec 17 15:28:05 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef RCS_OBSERVERN_HH
#define RCS_OBSERVERN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define PLANT_ORDER 4


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define RCS_OBSERVER_STATUS_TYPE 1000
#define RCS_OBSERVER_HALT_TYPE 1001
#define RCS_OBSERVER_INIT_TYPE 1002
#define RCS_OBSERVER_RUN_TYPE 1003
#define RCS_OBSERVER_SET_GAINS_TYPE 1004
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class RCS_OBSERVER_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	RCS_OBSERVER_STATUS();

	// Constructor used by derived classes
	RCS_OBSERVER_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double observer_state[PLANT_ORDER];
  double current_time;
  double ctrl_input;
  double plant_output;
};

// Command Classes

class RCS_OBSERVER_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	RCS_OBSERVER_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RCS_OBSERVER_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	RCS_OBSERVER_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double cycle_time;

};

class RCS_OBSERVER_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	RCS_OBSERVER_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int  num_sim_per_cycle;
  double initial_time;
  double initial_state[PLANT_ORDER];

};

class RCS_OBSERVER_SET_GAINS : public RCS_CMD_MSG
{
public:

	//Constructor
	RCS_OBSERVER_SET_GAINS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double observer_gains[PLANT_ORDER];

};

// Declare NML format function
extern int rcs_observerFormat(NMLTYPE, void *, CMS *);

#endif 	// RCS_OBSERVERN_HH
