/*
rcs_observer.cc

This C++ file defines member functions for the class RCS_OBSERVER_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Sun Dec 17 15:28:06 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rcs_observer.hh" 	// RCS_OBSERVER_MODULE definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "rcs_observern.hh" 	// NML Commands and Status definitions for rcs_observer
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
RCS_OBSERVER_MODULE::RCS_OBSERVER_MODULE(int _is_base_class)
  : OBSERVER(PLANT_ORDER)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
	if(!_is_base_class)
	{
		INITIALIZE_NML();
	}

	// Add additional code to initialize the module here.
	if (observer_err != OBSERVER_NO_ERROR)
	  {
	    logError("Error in creating RCS_OBSERVER_MODULE object!!!");
	    status = RCS_ERROR; // let my supervisor know I have a problem.
	  }
	

}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void RCS_OBSERVER_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "rcs_observer", "rcs_observer.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(rcs_observerFormat, "rcs_observer_cmd", "rcs_observer", "rcs_observer.nml"));
	rcs_observer_status = new RCS_OBSERVER_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(rcs_observerFormat, "rcs_observer_sts", "rcs_observer", "rcs_observer.nml"), rcs_observer_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.
*/
void RCS_OBSERVER_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code

  // Read the plant input and the plant output (they both are inputs to the observer)
  // ctrl_input[0] = the control input to the plant
  // ctrl_input[1] = the output of the plant

  ctrl_input[0] = 0;
  ctrl_input[1] = 0;


}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.
*/
void RCS_OBSERVER_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case RCS_OBSERVER_INIT_TYPE:
		INIT((RCS_OBSERVER_INIT *)commandInData);
		break;

	case RCS_OBSERVER_HALT_TYPE:
		HALT((RCS_OBSERVER_HALT *)commandInData);
		break;

	case RCS_OBSERVER_RUN_TYPE:
		RUN((RCS_OBSERVER_RUN *)commandInData);
		break;

	case RCS_OBSERVER_SET_GAINS_TYPE:
		SET_GAINS((RCS_OBSERVER_SET_GAINS *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.
*/
void RCS_OBSERVER_MODULE::POST_PROCESS()
{
	// Post-Processing Code
  // Report the current time, inputs to the observer and the observer  state
  rcs_observer_status->current_time = current_time;
  rcs_observer_status->ctrl_input = ctrl_input[0];
  rcs_observer_status->plant_output = ctrl_input[1];
  memcpy(rcs_observer_status->observer_state, plant_state, plant_order*sizeof(double));

}

// Command Functions

/*
INIT

Parameter(s):
RCS_OBSERVER_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void RCS_OBSERVER_MODULE::INIT(RCS_OBSERVER_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
          cycle_time = cmd_in->cycle_time;
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
RCS_OBSERVER_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void RCS_OBSERVER_MODULE::HALT(RCS_OBSERVER_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
RUN

Parameter(s):
RCS_OBSERVER_RUN *cmd_in -- NML Message sent from superior.

*/
void RCS_OBSERVER_MODULE::RUN(RCS_OBSERVER_RUN *cmd_in)
{
	// Put state table for RCS_OBSERVER_RUN here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      num_sim_per_cycle = cmd_in->num_sim_per_cycle;
      init_param(cycle_time/num_sim_per_cycle, 
                 cmd_in->initial_time,
                 cmd_in->initial_state);
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Simulate the system
      for (int ii = 0; ii < num_sim_per_cycle; ii++)
	{
	  solve();
	}
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
  
}

/*
SET_GAINS

Parameter(s):
RCS_OBSERVER_SET_GAINS *cmd_in -- NML Message sent from superior.

*/
void RCS_OBSERVER_MODULE::SET_GAINS(RCS_OBSERVER_SET_GAINS *cmd_in)
{
	// Put state table for RCS_OBSERVER_SET_GAINS here.
   if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      set_gains(cmd_in->observer_gains); 
      status = RCS_DONE;
      stateNext(S2);
 
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
 
}


void RCS_OBSERVER_MODULE::DERIV(const double t, const double *x,
				const double *u, double *xdot)
{
  // This is where the derivative should be defined in the
  // form: xdot = f(t,x,u), where t is the time, x the current state,
  // u is the current control input, and xdot is the derivative to be
  // computed here
  
  // Implement your system in the form
  // xhatdot = A*xhat + B*u[0] + L*(u[1] - C*xhat);
  // where u[0] is the control input to the original system and
  // u[1] is the output of the actual system
  // i.e., u[1] = y = C*x

}

