/*
rcs_observer.hh

This C++ header file defines the class RCS_OBSERVER_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Sun Dec 17 15:28:05 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef RCS_OBSERVER_HH
#define RCS_OBSERVER_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "observer.hh"  // OBSERVER definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "rcs_observern.hh" 	// NML Commands and Status definitions for rcs_observer
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class RCS_OBSERVER_MODULE: public NML_MODULE, public OBSERVER
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	RCS_OBSERVER_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(RCS_OBSERVER_INIT *);
	virtual void HALT(RCS_OBSERVER_HALT *);
	virtual void RUN(RCS_OBSERVER_RUN *);
	virtual void SET_GAINS(RCS_OBSERVER_SET_GAINS *);

	// Convenience Variables
	RCS_OBSERVER_STATUS *rcs_observer_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

  // Overload DERIV function of RK4_SIM (OBSERVER) for the simulator
  // to implement the dynamics of my plant
  // DERIV contains the dynamic equations of the system in the 
  // form: xdot = f(t,x,u); arguments are the time t, present state 
  // values x, the present control value u, and values of the derivatives 
  // of the states xdot (calculated inside of the funtcion). 
  // It is defined in RK4_SIM class and overloaded here
  virtual void DERIV(const double t, const double *x, 
                    const double *u, double *xdot);
  

private:
	// Add custom variables and functions here.
  int num_sim_per_cycle; // # of simulations to be performed per sampling time
  double cycle_time; // The cycle time for the module

};

#endif 	// RCS_OBSERVER_HH

